package xmljson.json.parsing;

import com.google.gson.stream.*;

import java.io.*;

public class JsonStreamInputExample {
	
	public static void run(File file) throws Exception {
		
		// Use JSON streaming parser (tokenizer) to find list of CD titles and artists
		
		try (FileReader fileReader = new FileReader(file)) {
			try (JsonReader jsonReader = new JsonReader(fileReader)) {
				
				jsonReader.beginObject();
				
				String name = jsonReader.nextName();
				if (!name.equals("CATALOG"))
					throw new Exception();
				
				jsonReader.beginArray();
				
				String title = "";
				String artist = "";

				while (jsonReader.peek() == JsonToken.BEGIN_OBJECT) {
					
					jsonReader.beginObject();
					
					name = jsonReader.nextName();
					if (!name.equals("CD"))
						throw new Exception();
					
					jsonReader.beginObject();

					while (jsonReader.peek() == JsonToken.NAME) {
						String propName = jsonReader.nextName();
						switch (propName) {
							case "TITLE":
								title = jsonReader.nextString();
								break;
							case "ARTIST":
								artist = jsonReader.nextString();
								break;
							default:
								jsonReader.skipValue();
								break;
						}
					}

					System.out.println(title + ", " + artist);

					jsonReader.endObject();
					
					jsonReader.endObject();
				}
			
				jsonReader.endArray();
				jsonReader.endObject();
			}
		}
	}
	
}
